<div>
  <a [routerLink]="['/admin']" class="home"
    ><mat-icon>admin_panel_settings</mat-icon></a
  >
</div>
<div *ngIf="isLoaded">
  <div class="mat-elevation-z8">
    <table
      mat-table
      [dataSource]="dataSource"
      matSort
      (matSortChange)="sortUsers($event)"
    >
      <ng-container matColumnDef="id">
        <th mat-header-cell *matHeaderCellDef mat-sort-header>ID</th>
        <td mat-cell *matCellDef="let row">{{ row.id }}</td>
      </ng-container>

      <ng-container matColumnDef="firstName">
        <th mat-header-cell *matHeaderCellDef mat-sort-header>First Name</th>
        <td mat-cell *matCellDef="let row">{{ row.firstName }}</td>
      </ng-container>

      <ng-container matColumnDef="lastName">
        <th mat-header-cell *matHeaderCellDef mat-sort-header>Last Name</th>
        <td mat-cell *matCellDef="let row">{{ row.lastName }}</td>
      </ng-container>

      <ng-container matColumnDef="email">
        <th mat-header-cell *matHeaderCellDef mat-sort-header>Email</th>
        <td mat-cell *matCellDef="let row">{{ row.email }}</td>
      </ng-container>

      <ng-container matColumnDef="isAdmin">
        <th mat-header-cell *matHeaderCellDef>Is admin</th>
        <td mat-cell *matCellDef="let row">
          <mat-checkbox
            [(ngModel)]="row.isAdmin"
            (change)="changeAdminRights(row)"
          >
          </mat-checkbox>
        </td>
      </ng-container>

      <ng-container matColumnDef="registrationDate">
        <th mat-header-cell *matHeaderCellDef mat-sort-header>
          Registration Date
        </th>
        <td mat-cell *matCellDef="let row">
          {{ row.registrationDate | date: "short" }}
        </td>
      </ng-container>

      <ng-container matColumnDef="actions">
        <th mat-header-cell *matHeaderCellDef>
          <button mat-icon-button color="primary" (click)="addUser()">
            <mat-icon>add</mat-icon>
          </button>
        </th>
        <td mat-cell *matCellDef="let user">
          <button mat-raised-button (click)="deleteUser(user.id)">
            <mat-icon>delete</mat-icon>
          </button>
        </td>
      </ng-container>

      <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
      <tr mat-row *matRowDef="let row; columns: displayedColumns"></tr>
    </table>

    <mat-paginator
      [length]="totalSize"
      [pageSize]="pageSize"
      [pageIndex]="currentPage"
      [pageSizeOptions]="[5, 10, 25]"
      (page)="handlePage($event)"
    ></mat-paginator>
  </div>
</div>

<div
  class="d-flex justify-self-center align-self-center h-100"
  *ngIf="!isLoaded"
>
  <mat-spinner style="margin: 0 auto"></mat-spinner>
</div>
